package com.nisum.ascend.promotions.service;

import com.nisum.ascend.promotions.dto.PromotionDto;
import com.nisum.ascend.promotions.repository.PromotionRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.reactive.function.BodyInserters;
import reactor.core.publisher.Flux;
import reactor.core.scheduler.Schedulers;

import java.util.List;

import static org.springframework.http.ResponseEntity.notFound;
import static org.springframework.http.ResponseEntity.ok;

@Service
public class PromotionService {

    @Autowired
    PromotionRepository promotionRepository;

    public Flux<PromotionDto> findAll(){
        return promotionRepository.findAll().map(PromotionDto::generateDtoFromPromotion);
    }

    public Flux<PromotionDto> findPromotionsByProductSku(String sku){
        return promotionRepository.findByProductSku(sku).map(PromotionDto::generateDtoFromPromotion);
    }

    public Flux<PromotionDto> bulkSearchSku(List<String> skus){

        return Flux.fromIterable(skus)
                .flatMap(sku -> findPromotionsByProductSku(sku));
    }

}
